--- channels/chan_sip.c.orig	2010-08-19 23:05:54.000000000 +0200
+++ channels/chan_sip.c	2010-09-21 21:24:53.000000000 +0200
@@ -6833,9 +6833,10 @@ static struct ast_channel *sip_new(struc
 	 * we should decode the uri before storing it in the channel, but leave it encoded in the sip_pvt
 	 * structure so that there aren't issues when forming URI's
 	 */
-	decoded_exten = ast_strdupa(i->exten);
-	ast_uri_decode(decoded_exten);
-	ast_copy_string(tmp->exten, decoded_exten, sizeof(tmp->exten));
+	//decoded_exten = ast_strdupa(i->exten);
+	//ast_uri_decode(decoded_exten);
+	//ast_copy_string(tmp->exten, decoded_exten, sizeof(tmp->exten));
+	ast_copy_string(tmp->exten, i->exten, sizeof(tmp->exten));
 
 	/* Don't use ast_set_callerid() here because it will
 	 * generate an unnecessary NewCallerID event  */
@@ -13527,25 +13528,30 @@ static int get_destination(struct sip_pv
 		char hint[AST_MAX_EXTENSION];
 		return (ast_get_hint(hint, sizeof(hint), NULL, 0, NULL, p->context, p->exten) ? 0 : -1);
 	} else {
-		decoded_uri = ast_strdupa(uri);
-		ast_uri_decode(decoded_uri);
+//		decoded_uri = ast_strdupa(uri);
+//		ast_uri_decode(decoded_uri);
 		/* Check the dialplan for the username part of the request URI,
 		   the domain will be stored in the SIPDOMAIN variable
 		   Since extensions.conf can have unescaped characters, try matching a decoded
 		   uri in addition to the non-decoded uri
 		   Return 0 if we have a matching extension */
-		if (ast_exists_extension(NULL, p->context, uri, 1, S_OR(p->cid_num, from)) || ast_exists_extension(NULL, p->context, decoded_uri, 1, S_OR(p->cid_num, from)) ||
-		    !strcmp(decoded_uri, ast_pickup_ext())) {
+//		if (ast_exists_extension(NULL, p->context, uri, 1, S_OR(p->cid_num, from)) || ast_exists_extension(NULL, p->context, decoded_uri, 1, S_OR(p->cid_num, from)) ||
+//		    !strcmp(decoded_uri, ast_pickup_ext())) {
+		if (ast_exists_extension(NULL, p->context, uri, 1, S_OR(p->cid_num, from)) || !strcmp(uri, ast_pickup_ext())) {
+		
 			if (!oreq)
-				ast_string_field_set(p, exten, decoded_uri);
+//				ast_string_field_set(p, exten, decoded_uri);
+				ast_string_field_set(p, exten, uri);
 			return 0;
 		} 
 	}
 
 	/* Return 1 for pickup extension or overlap dialling support (if we support it) */
 	if((ast_test_flag(&global_flags[1], SIP_PAGE2_ALLOWOVERLAP) && 
- 	    ast_canmatch_extension(NULL, p->context, decoded_uri, 1, S_OR(p->cid_num, from))) ||
-	    !strncmp(decoded_uri, ast_pickup_ext(), strlen(decoded_uri))) {
+// 	    ast_canmatch_extension(NULL, p->context, decoded_uri, 1, S_OR(p->cid_num, from))) ||
+//	    !strncmp(decoded_uri, ast_pickup_ext(), strlen(decoded_uri))) {
+ 	    ast_canmatch_extension(NULL, p->context, uri, 1, S_OR(p->cid_num, from))) ||
+	    !strncmp(uri, ast_pickup_ext(), strlen(uri))) {
 		return 1;
 	}
 	
@@ -17658,7 +17664,7 @@ static void parse_moved_contact(struct s
 		e = strchr(s, ';');	/* And username ; parameters? */
 		if (e)
 			*e = '\0';	
-		ast_uri_decode(s);
+		ast_uri_decode(s); // unsure about this one..
 		ast_debug(2, "Received 302 Redirect to extension '%s' (domain %s)\n", s, domain);
 		if (p->owner) {
 			pbx_builtin_setvar_helper(p->owner, "SIPDOMAIN", domain);
@@ -20196,10 +20202,10 @@ static int handle_request_invite(struct 
 				char *decoded_exten = ast_strdupa(p->exten);
 
 				transmit_response_reliable(p, "404 Not Found", req);
-				ast_uri_decode(decoded_exten);
+				//ast_uri_decode(decoded_exten);
 				ast_log(LOG_NOTICE, "Call from '%s' to extension"
 					" '%s' rejected because extension not found in context '%s'.\n",
-					S_OR(p->username, p->peername), decoded_exten, p->context);
+					S_OR(p->username, p->peername), p->exten, p->context);
 			}
 			p->invitestate = INV_COMPLETED;
 			update_call_counter(p, DEC_CALL_LIMIT);
